/* eslint-disable camelcase */
const UserModel = require('../../../models/UserModel')
const jwt = require('jsonwebtoken')

const setExpertise = async (req, res, next) => {
  try {
    const token = req.header('Authorization').split(' ')[1]
    if (!token) return res.status(401).send('Access Denied')
    const { expertise, sub_expertise } = req.body
    if (!expertise || !sub_expertise) {
      return res.status(422).json({
        error: true,
        message: 'اطلاعات ارسالی اشتباه است'
      })
    }

    // جستجوی کاربر با شماره موبایل ارسالی
    const decodedToken = jwt.verify(token, process.env.APP_SECRET)
    const user = await UserModel.findById(decodedToken.id)
    if (!user) {
      return res.status(404).json({
        error: true,
        message: 'کاربری با این شماره موبایل یافت نشد'
      })
    }

    // آپدیت نام کاربری به صورت lowercase
    user.expertise = expertise
    user.sub_expertise = sub_expertise
    await user.save()

    return res.json({
      message: 'تخصص با موفقیت به‌روزرسانی شد'
    })
  } catch (error) {
    next(error)
  }
}

const updateExpertise = async (req, res, next) => {
  try {
    const token = req.header('Authorization').split(' ')[1]
    if (!token) return res.status(401).send('Access Denied')

    const { expertise, sub_expertise } = req.body

    // اعتبارسنجی داده‌ها
    if (!expertise || !sub_expertise) {
      return res.status(422).json({
        error: true,
        message: 'اطلاعات ارسالی ناقص است'
      })
    }

    const decodedToken = jwt.verify(token, process.env.APP_SECRET)
    const userId = decodedToken.id

    // یافتن کاربر با استفاده از شناسه کاربر
    const user = await UserModel.findById(userId)
    if (!user) {
      return res.status(404).json({
        error: true,
        message: 'کاربری با این شناسه یافت نشد'
      })
    }

    // به‌روزرسانی اطلاعات تخصص و زیرتخصص
    user.expertise = expertise
    user.sub_expertise = sub_expertise
    await user.save()

    return res.json({
      message: 'تخصص با موفقیت به‌روزرسانی شد'
    })
  } catch (error) {
    next(error)
  }
}
module.exports = {
  setExpertise, updateExpertise
}
